﻿    var HeroList = HeroList || [];
    //查询变量保存
    var serachKeyCache = {
        HeroType: [],
        HeroSourse: [],
        HeroName: ""
    }

    //当前英雄数据查询结果
    var curtHeroList;

    //页大小
    var pageSize = 12;

    //当前页码
    var pageIndex = 1;


    //查找当前英雄的数据已经当前使用的加点方案数据
    function findHeroByHeroIdAndSchemeId(heroId, schemeid) {
        for (var i = 0; i < curtHeroList.length; i++) {
            var tmpHero = curtHeroList[i];
            //找英雄
            if (tmpHero.HeroId == heroId) {
                //找方案
                var tmpScheme = {};
                if (tmpHero.SchemeList) {
                    for (var j = 0; j < tmpHero.SchemeList.length; j++) {
                        if (tmpHero.SchemeList[j].SchemeId == schemeid) {
                            tmpScheme = tmpHero.SchemeList[j];
                        }
                    }
                }
                return GetWebMutualSoftHeroObj(tmpHero, tmpScheme);
            }
        }
    }

    //获取与软件交互的Hero参数对象
    function GetWebMutualSoftHeroObj(hero, scheme) {
        var result = {
            HeroName: hero.HeroName || "",
            HeroId: hero.HeroId || "",
            SchemeId: 0,
            Scheme: null
        };
        if (!hero) return result;
        if (scheme) {
            result.SchemeId = scheme.SchemeId;
            result.Scheme = scheme;
        }
        return result;
    }

    //比对SearchKey
    function comparisonAndUpdateSearchKey() {
        var result = true;
        var curtSearchKey = GetSearchKeyByPage();
        //alert(JSON.stringify(serachKeyCache));
        //alert(JSON.stringify(curtSearchKey));
        //比对英雄名称
        if (curtSearchKey.HeroName != serachKeyCache.HeroName) {
            result = false;
            serachKeyCache.HeroName = curtSearchKey.HeroName;
        }
        //比对英雄类型
        if (curtSearchKey.HeroType.length != serachKeyCache.HeroType.length ||
            curtSearchKey.HeroType.toString() != serachKeyCache.HeroType.toString()
            ) {
            result = false;
            serachKeyCache.HeroType = curtSearchKey.HeroType;
        }
        //比对英雄源
        if (curtSearchKey.HeroSourse.length != serachKeyCache.HeroSourse.length ||
            curtSearchKey.HeroSourse.toString() != serachKeyCache.HeroSourse.toString()
            ) {
            result = false;
            serachKeyCache.HeroSourse = curtSearchKey.HeroSourse;
        }
        return result;
    }

    //获取当前页面选定的查询条件
    function GetSearchKeyByPage() {
        var result = {
            HeroType: [],
            HeroSourse: [],
            HeroName: $("#SerachHeroName").val()
        };
        var heroTypes = $("#ULHeroType .cur");
        for (var i = 0; i < heroTypes.length; i++) {
            result.HeroType.push(parseInt(heroTypes.eq(i).attr("herotype")));
        }
        var heroSourse = $("#ULHeroSourse .cur");
        for (var i = 0; i < heroSourse.length; i++) {
            result.HeroSourse.push(parseInt(heroSourse.eq(i).attr("herosourse")));
        }
        //排序一下
        result.HeroType.sort();
        result.HeroSourse.sort();
        return result;
    }
    
    //数据展示
    function dataShow() {
        if (!curtHeroList) {
            //加载
            dataSearch();
        }
        //alert(JSON.stringify(curtHeroList));

        //请求软件接口的参数数组
        var mutualParms = [];

        //处理分页码
        var startIndex = (pageIndex - 1) * pageSize;
        var endIndex = startIndex + pageSize;

        if (startIndex >= curtHeroList.length) {
            startIndex = curtHeroList.length - 1;
        }
        if (endIndex >= curtHeroList.length) {
            endIndex = curtHeroList.length;
        }
        
        var divHero = $("#hero");
        divHero.children("li").remove();
        
        if (endIndex <= 0) return;
        
        for (var i = startIndex; i < endIndex; i++) {
            var hero = curtHeroList[i];
            //alert("i:" + i + "|" + JSON.stringify(hero));

            //var divHeroLi = divHero.children("li[heroid='" + hero.HeroId + "']");
            //if (divHeroLi.length <= 0) {
            var html = template('heroTemplate', hero);
                ////拼接html
                //html += '<li heroid="' + hero.HeroId + '" >' +
                //            '<div class="bg">' +
                //                hero.HeroName +
                //            '</div>' +
                //            '<img src="' + hero.HeroHeadImg + '" />' +
                //            '<div class="heroSelect">' +
                //                '<div class="Left type" heroid="' + hero.HeroId + '" curtschemeid="0">' +
                //                (hero.SchemeList && hero.SchemeList.length > 0 ? hero.SchemeList[0].SchemeName : "") +
                //                '</div>' +
                //                '<a href="javascript:;" hidefocus="hidefocus" class="Right down"></a>' +
                //                '<div class="heroSelectBody hide">';
                //for (var ii = 0; ii < hero.SchemeList.length; ii++) {
                //    var tmpScheme = hero.SchemeList[ii];
                //    html += '<a href="javascript:;"  heroid="' + hero.HeroId + '" schemeid="' + tmpScheme.SchemeId + '" hidefocus="hidefocus">' + (tmpScheme.SchemeName.length > 5 ? tmpScheme.SchemeName.substr(0, 5) : tmpScheme.SchemeName) + '</a>';
                //}
                //html += '</div>' +
                //    '</div>' +
                //    '<div class="details hide">' +
                //        '<div class="detailsBg"></div>' +
                //        '<a href="javascript:" btntype="showschemeinfo" heroname="' + hero.HeroName + '" heroid="' + hero.HeroId + '" hidefocus="hidefocus">天赋详情</a>' +
                //    '</div>' +
                //'</li>';
                divHero.append(html);
            //}
            //软件请求的参数
            mutualParms.push(GetWebMutualSoftHeroObj(hero));
            //divHeroLi.show();
        }
        

        //解决IE6.7浏览器下下拉框被第二行遮住的问题
        var curtVisibleHeroLi = divHero.children("li:visible");
        if (curtVisibleHeroLi.length > 6) {
            curtVisibleHeroLi.each(function (i) {
                if (i < 6) {
                    $(this).css("zIndex", 1);
                }
            });
        }

        //调用软件接口,获取英雄方案选择的状态并且更新到页面上
        updateHeroSchemeChoose(mutualParms);
    }

    //function update
    //调用软件接口,获取英雄方案选择的状态并且更新到页面上
    function updateHeroSchemeChoose(mutualParms) {
        //改变当前下拉框选中状态
        var heroSchemeInfoList = fbyxTalentSimulatorSoftAPI.getHeroJiaDianInfo(mutualParms);
        if (heroSchemeInfoList) {
            for (var i = 0; i < heroSchemeInfoList.length; i++) {
                var heroJiaDianInfo = heroSchemeInfoList[i];
                if (heroJiaDianInfo.SchemeId > 0) {
                    var heroCurtschemeDiv = $("#hero .heroSelect div[heroid='" + heroJiaDianInfo.HeroId + "'][curtschemeid]");
                    heroCurtschemeDiv.html($("#hero .heroSelect div.heroSelectBody a[heroid='" + heroJiaDianInfo.HeroId + "'][schemeid='" + heroJiaDianInfo.SchemeId + "']:first").html());
                    heroCurtschemeDiv.attr("curtschemeid", heroJiaDianInfo.SchemeId);
                }
            }
        }
    }
    

    //数据查询
    function dataSearch() {

        //比对查询条件 如果查询条件没变过,那么就不查询了
        if (comparisonAndUpdateSearchKey() && curtHeroList) {
            //加载
            dataShow();
            return;
        }

        curtHeroList = [];
        //如果没有原数据 底下就不执行了
        if (!HeroList || HeroList.length <= 0) { return; }

        for (var i = 0; i < HeroList.length; i++) {
            var tmpHero = HeroList[i];
            //效验英雄名
            if (serachKeyCache.HeroName != "" && tmpHero.HeroName.indexOf(serachKeyCache.HeroName) < 0) {
                //alert(serachKeyCache.HeroName + "|" + tmpHero.HeroName + "|" + tmpHero.HeroName.indexOf(serachKeyCache.HeroName));
                continue;
            }
            //效验英雄来源
            if (serachKeyCache.HeroSourse.length > 0 && serachKeyCache.HeroSourse.toString().indexOf(tmpHero.HeroSourse) < 0) {
                continue;
            }
            //先从小到大排序
            tmpHero.HeroTypeList.sort();
            //效验英雄类型
            if (serachKeyCache.HeroType.length > 0 && tmpHero.HeroTypeList.toString().indexOf(serachKeyCache.HeroType.toString()) < 0) {
                continue;
            }
            curtHeroList.push(tmpHero);
        }
        //整理分页HTML
        pageIndex = 1;
        var sumPage = (curtHeroList.length % pageSize == 0 ? parseInt(curtHeroList.length) / pageSize : parseInt(curtHeroList.length / pageSize) + 1);
        var divPage = $("#divPage");
        divPage.children("a").remove();
        if (sumPage > 1) { //超过1页才显示页码
            for (var i = 0; i < sumPage; i++) {
                divPage.append(template("pageTemplate", { index: i+1 }));
            }
            divPage.children("a:first").addClass("cur");
        }
        //没有搜到数据
        if (curtHeroList.length == 0) {
            $("#fbSearchNoData").show()
        } else {
            $("#fbSearchNoData").hide();
        }
        dataShow();
    }

    //初始化,绑定一些事件
    (function () {
        //搜索查询框效果 start --------
        var serachHeroNameTime = null;
        var serachHeroNameBlurTime = null;
        //查询的英雄名input框
        var serachHeroName = $("#SerachHeroName");
        var ulSerachHeroNameLike = $("#ULSerachHeroNameLike");
        var divSerachHeroNameLike = $('#DivSerachHeroNameLike');
        

        ulSerachHeroNameLike.delegate("li a", "click", function () {
            serachHeroName.val($(this).html()).focus();
            window.clearTimeout(serachHeroNameBlurTime);
            divSerachHeroNameLike.hide();
            dataSearch();
        });

        serachHeroName.keyup(function (e) {
            //是否回车搜索
            if (e.keyCode == 13) {
                divSerachHeroNameLike.hide();
                dataSearch();
                return;
            }
            window.clearTimeout(serachHeroNameTime);
            serachHeroNameTime = setTimeout(function () {
                window.clearTimeout(serachHeroNameBlurTime);
                ulSerachHeroNameLike.children('li').remove();
                divSerachHeroNameLike.hide();
                var searchName = $.trim(serachHeroName.val());
                if (!searchName) return;
                for (var i = 0; i < HeroList.length; i++) {
                    var hero = HeroList[i];
                    if (hero.HeroName.indexOf(searchName) > -1) {
                        ulSerachHeroNameLike.append(template('serachHeroNameLikeTemplate', { HeroName: hero.HeroName }));
                    }
                }
                if (ulSerachHeroNameLike.children("li").length > 0) {
                    divSerachHeroNameLike.show().zScroll();
                }
            }, 200);
        }).blur(function () {
            window.clearTimeout(serachHeroNameBlurTime);
            serachHeroNameBlurTime = setTimeout(function () {
                divSerachHeroNameLike.hide();
            }, 500);
            window.isSelectstart = false;
        }).focus(function () {
            window.isSelectstart = true;
        });
        
        window.isSelectstart = false;
        document.onselectstart = function () {
            return window.isSelectstart;
        }

        //搜索查询框效果 end --------

        //英雄类型
        $("#ULHeroType a[herotype]").click(function () {
            var T = $(this);
            if (T.hasClass("cur")) {
                T.removeClass("cur");
            } else {
                $("#ULHeroType a.cur").removeClass("cur");
                T.addClass("cur");
            }
            dataSearch();
            return false;
        });
        //英雄源筛选
        $("#ULHeroSourse a[herosourse]").click(function () {
            var T = $(this);
            if (T.hasClass("cur")) {
                T.removeClass("cur");
            } else {
                $("#ULHeroSourse a.cur").removeClass("cur");
                T.addClass("cur");
            }
            dataSearch();
            return false;
        });

        //搜索按钮
        $("#btnSearch").click(function () { 
            dataSearch();
        });

        //绑定分页点击事件
        $("#divPage").delegate("a", "click", function () {
            var T = $(this);
            if (T.hasClass("cur")) return;
            $("#divPage .cur").removeClass("cur");
            $(this).addClass("cur");
            pageIndex = parseInt(T.html());
            dataShow();
            return false;
        });

        //方案选择下拉框
        $("#hero").delegate(".heroSelect>.down", "click", function () {
            var paentT = $(this).parent();
            var heroSelectBody = paentT.find(".heroSelectBody");
            heroSelectBody.show();
            //如果模拟滚动条没有初始化进行初始化一下
            if (!heroSelectBody.attr("isInitSrcoll")) {
                heroSelectBody.zScroll().attr("isInitSrcoll", "1");
            }
            paentT.siblings('div.details').hide();
        }).delegate(".heroSelect", "mouseleave", function () {
            var T = $(this);
            T.find(".heroSelectBody").hide();
            T.siblings('div.details').show();
        }).delegate("a[heroid][schemeid]", "click", function () {
            var T = $(this);
            var heroId = T.attr("heroid");
            var schemeid = T.attr("schemeid");
            T.parents(".heroSelect:first").find("div[curtschemeid]").html(T.html()).attr("curtschemeid", schemeid);
            T.parents(".heroSelectBody:first").hide();
            fbyxTalentSimulatorSoftAPI.updateHeroJiaDianInfo(findHeroByHeroIdAndSchemeId(heroId, schemeid));
        }).delegate("a[heroid][btntype='showschemeinfo']", "click", function () {
            var T = $(this);
            var heroId = parseInt(T.attr("heroid"));
            var heroName = T.attr("heroname");
            fbyxTalentSimulatorSoftAPI.openJiaDianInfoWindow(GetWebMutualSoftHeroObj({ HeroId: heroId, HeroName: heroName }));
        }).delegate("li", "mouseenter", function () {
            $(this).find('div.details').show();
        }).delegate("li", "mouseleave", function () {
            $(this).find('div.details').hide();
        });
        //返回首页按钮
        $("#btnGoBack").click(function () {
            $("#ULHeroType a.cur").removeClass("cur");
            $("#ULHeroSourse a.cur").removeClass("cur");
            $("#SerachHeroName").val('');
            dataSearch();
        });
        
        //加载页面数据
        dataSearch();
    })();

 